
 ~ GameType-Revolution a fun mod for Quake 4 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   Date:  March, 2006
   Url:   http://gtr.quakedev.com/
   Mail:  TTK-Bandit@my-mail.ch

   Feel free to visit us at #GT-Revolution on QuakeNet and EnterTheGame :)

 ~ History ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   v0.15 ~ May  7th, 2006

     add: 1.2 support
     add: Quake4World parts (movement, weapons, items, teleporter)
          thx to calimero and Quake4World for the sourcecode.
     add: Quake4World config
     add: QuakeWorld config (the one from q4w)
     add: server cvars to make q4w optional possible:
           - pm_accelType
           - pm_doubleJump
           - g_instantWeaponSwitch
           - g_teleportStyle

     add: g_traineeMode for different weapon trainee modes.
          (instagib, midair,..,freestyle)
          and of course a callvote traineemode option.
     add: midair settings for traineeMode 6
     add: instagib settings for traineeMode 7
     add: freestyle (defrag like; all weapons, no damage) for traineeMode 10
     add: beta mappak for midair: mp/midair1, mp/midair2
     add: cl_buttonConfig* cvars for userdefined button actions (up/down)
     add: real brightskins for id software's brightskins
     add: small gamemode descriptions: docs/gamemodes.txt

     chg: BaseQ4 config supports now original weaponbalance,
          movement and hitboxes
     chg: removed g_instaGib cvar and the vote for it
          (instagib is now traineemode 7)
     chg: made shotgun spread more consistent in gtr mode
     chg: improved the q4 feeling (in gtr/q4w/qw mode) by:
           - lowering the bbox height from 77 to 74
             (74 is singleplayerheight, dunno why they raised it for mp)
           - raising the crouchviewheight from 32 to 34
           - lowering the normalviewheight from 68 to 62
           - improving the waterfriction.
           - adding an extra projectilespawnpoint offset (weapon specific)
             (projectiles spawn in front of your weapon instead of your eyes)
             (rocketjumps feel better; not delayed anymore)

     chg: improved the q4 feeling (in gtr mode) by:
           - increasing the ground- and air- acceleration
           - lowering the rocketknockback from 120 to 110

     chg: new entitydef access with partial code by q4f (thx to 3j)
          for updating the player and weapon entitydefs
          This was needed to include the Q4W and QW changes.

     chg: removed the "voteable" config, as it's not used anymore.
     chg: removed g_fastWeaponSwitch variable

     fix: fixed double explosions on rocketlauncher
     fix: showjumps showing 0 units if not playing on listenserver
     fix: showjumps now shows you distance to the teleporter,
          so in tj_home and similar maps, you can see how far you jumped.
          known bug: it only works on listenserver.
     fix: wrong r_skipSpecular & r_displayRefresh declarations

     fix: bug, that you were able to crouch if not onground (in gtr mode)
     fix: bug, that lighting at the first second of a match switches back to
          non-ambientlightonly.
     fix: made foreshorten weaponspecific
          (if fov > 110, it stretches the gun, so it looks close to fov 110)
     fix: killed player in ClanArena could not see teamoverlay.
     fix: killed player in ClanArena was removed from teamoverlay.


    info: grappling hook was added in 0.12i, but disabled in 0.15, as it doesn't
          fit the gtr gameplay. As soon as it's adapted, It will be re-enabled.

    info: midair in 0.13a and older has calculated damage on the playerheight.
          in 0.15, it depends on the time the player has been in the air.

   v0.12 ~ March  31st, 2006

     add: made cylindric(hexagonal) hitboxes default
     add: now using the weaponbalance we got as result from the balance tests.
     fix: various small bugs

   v0.10 beta5Test ~ March  29rd, 2006

     add: 1.1 final support
     add: different weaponbalance valuesets
     add: new hitbox system (cylindric/hexagonal instead of just a box)
     chg: changed coach icon
     fix: ping shown wrong in scoreboard

   v0.10 beta4 ~ March  12rd, 2006

     add: performance tweaks
     add: 'oneflag ctf' gametype and voteoption.
     add: 'arena one flag ctf' gametype and voteoption.
     add: docs folder with readme, history and client/server commands
     chg: hardconfigs removed: kuh3liga, clanbase (as they won't play gtr anyway)
     chg: made GTR to default hardconfig, baseq4 can still be voted.

   v0.10 beta3 ~ March  7rd, 2006

     fix: converted the hud / menu stuff to 1.1
     fix: converted g_spawntype
     fix: converted demo recording for timeout
     chg: changed rev. number to v0.10b3
     chg: fileheader text adapted.
     chg: hyperblaster skin (inview) is now final version.
     add: UpdateBrightskins command so setting your team colors is faster.

   v0.10 beta2 ~ March  4rd, 2006

     fix: brightskins not working
     chg: brightskins now look much brighter, red looks as it should,
          and even black 'bright'skins are possible now.
     fix: simpleitems drawn with black background
     chg: cl_enemy/teamColorIntensity now defaults to 0 (to disable them)
     chg: cl_teamColor* defaults to :  ffffff (white)
     chg: cl_enemyColor* defaults to :  00ff00 (green)
     chg: removed stairjumps & smoothboxjumps cvars/votes
     chg: changed some gui files that where too old. (not converted to 1.1 yet)
     fix: readded voicechat stuff

   v0.10 beta1 ~ March  2nd, 2006

     chg: converted most stuff to id softwares patch 1.1beta
     add: added drachs inview weaponskins

 ~ X-Battle History (GTR is based on xbm 0.20) ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   v0.20 ~ February 28th, 2006

     fix: cl_weaponConfig(x) client game crash. now all 18 crosshairs are
          allowed.
     fix: demo / autorecord bug.
     fix: cl_weaponConfigX now allows all 18 crosshairs and no longer can
          crash the client.
     fix: missing grenade and dmg glow texture readded.
     fix: map location files now support all valid linebreaks formats and no
          longer cuts off the teamchat line.
     fix: hud wasnt drawn if g_skipViewEffects was enabled.
     fix: server log output now recognizes arenas in tourney games correctly.
     fix: hud no longer shows -1 for infinity ammo.
     fix: scorebot no longer shows wrong player ids.
     fix: spectators can no longer see teamchat from their old team.
     fix: chatline linebreaks now restores default messagemode color.
     fix: teamchats are no longer played with a publicchat sound.
     fix: auto-generated filesnames (demorecord) will now replace invalid chars
          with an _ (underline).
     add: timeout / timein / time command to pause/unpause a running match
     add: teammate hitsounds ( s_altHitsounds 1 only ).
     add: Q3 like damage feedback sounds depending on opponents health
          ( s_altHitsounds 1 only ).
     add: 'ClanArena' gametype and voteoption.
     add: 'InstaGib' gameplay.
     add: gametype 'Duel' as you know it from quake3.
     add: si_roundLimit to set roundlimit for round based games like CA
     add: match_timeoutLength to control the maximal length of a timeout
          before the game goes on.
     add: material water for map makers. like in q2dm1 or q3ctf2. mappers will
          soon find a tutorial on our homepage on how to add water in your
          own maps.
     add: different sound files for water effects.
     add: match_timeoutCount to control the maximum number of timeouts in 
          a game per team.
     add: match_overtime to control different types of overtime modes.
     add: match_overtimeLength to set length in minutes for each overtime round.
     add: match_overtimeCount to set the maximum number of overtime rounds before
          the match can end in a tie or switch to sudden death.
     add: server cvar match_fallingDamage.
     add: server cvar match_selfDamage.
     add: g_instaGib cvar to enable/disable instagib gameplay.
     add: 'instagib' as callvote option to (dis)allow instagib gameplay.
     add: netto stats in Team DM scoreboard.
     add: colored pings depending on ping times as you know it from osp.
     add: cl_gimmikMod ( whos the first? ).
     add: coach functionality from osp:
          ( coach, coachInvite, coachDecline, coachKick etc. )
     add: g_onlyArmorTD added to change between full and armor only teamdamage.
     chg: various fixes to improve gameplay smoothness.
     chg: sg glow adjusted.
     chg: si_teamDamage restored to id default to avoid a conflict with the
          current 1.0.6 linux patch.
     chg: all hud symbols and pickable items are now drawn in picmip 0 regardless
          of your image_downSize settings ( except ctf flags ).
     chg: new overtime + timeout control commands added to Kuh3Liga + ClanBase
          hardconfigs.
     chg: gameclock forced to be count up in overtime mode and clock color will 
          change to yellow to indicate overtime mode.
     chg: scoreboard background color changed to a transparent black.
     chg: all black colorcodes are replaced to white at the summary board.
          ( to allow readable auto-screenshots for leagues )
     chg: following player and waiting on more player string replaced to the top
          of the HUD.
     chg: addloc / delloc / listloc are no longer cheat protected commands.
     chg: weaponicon colored background border removed in statusbar and replaced
          with a real weapon icon.
     chg: statusbar font changed.

   v0.12 ~ January 22th, 2006

     fix: missing teamscore bug.
     fix: missing warmup weapons bug. this time for sure :)
     fix: nailgun bgcolor in weaponswitch
     fix: (raven/id bug) q4base will crash by trying to vote a map without flags
          in a ctf gametype.
     fix: small issue with g_maxRespawnTime fixed.
     add: cl_simpleItems to draw 3D models as 2D icons. (requested like hell)
     add: referee mode to force several match stuff. see client-commands for full
          details.
     add: forced configs to allow the forcing of standard settings for leagues.
          use callvote option setconfig <name> <gametype> to force a standard
          config. name can be : Quake4, XBattle, ClanBase, Kuh3Liga.
     add: enhanced log support.
          the following server commands were added to control the log support:
          g_statsLog           - enables statistics log output.
          g_statsLogEmptyGames - determines whether games with no player action
                                 will be logged or not.
          fs_statsPath         - path to statstics log file
     add: cl_statsUserName <string>, cl_statsPassword <string> to identify player
          in server statistics.
     add: chattokens for teamgames:
          #h - player health colored by value
          #H - player health
          #A - player armor
          #U - lists all powerups the player is currently wearing
          #w - player weapon as shortext. like RG for RailGun etc.
          #W - player weapon as icon.
          #D - damaged by. the last player which attacked you.
          #P - last item that was picked up.
          #I - nearest item name.
          #L - your location.
     add: r_skipWorldFX <bitmask> to remove some world effects.
           0 - Skip nothing
           1 - skips the drawing of the glow effects around items.
           2 - skips the drawing of the visual effects for item spawnpoints.
           4 - skips the drawing of the visual effects for jumppads.
           8 - skips the drawing of the visual effects for teleporter.
          16 - skips the drawing of the visual effects for fog, sparks
               and some more.

          To remove an effect just add his value.
          i.e : A value of 31 removes all visual effects!
          a value of 6 only removes the item spawnpoints and jumppad effects.
     add: user defined map-location support for the teamoverlay and teamchat.
          to add a location you can use the following commands :
          addloc <locationname> - to add a location. It will automaticly saved to
                                  the battle/locs folder. i.e.: mapname.cfg
          listloc               - displays all known locations for this map
          delloc <id>           - delete an entry out of the location-file.
     add: cl_editMapLocations to toggle the drawing of the area number in the
          teamoverlay on/off (useful for creating locationfiles)
     add: cl_weaponConfigs to allow the usage of separate settings for each
          weapon.
          The weapons-cfgs can be set with the cvars cl_weaponConfig0 up to
          cl_weaponConfig9.
          Arguments are : g_fov, sensitivity, ui_showGun, g_crosshairCustomFile,
          g_crosshairSize, g_crosshairColor in rgb hex color.
     add: si_autoAction <bitmask> to enforce several things from server-side
          bitmask:
          1 statsdump at the end of the match
          2 take endlevel screenshot
          4 records a demo
          So a value of 7 will do everything.
     add: cl_autoAction <bitmask> to enforce several things from client-side
          bitmask:
          1 statsdump at the end of the match
          2 take endlevel screenshot
          4 records a demo
          So a value of 7 will do everything.
     add: players / listplayers commands to list all players with id, team,
          flags (ref,coach,captain) and names.
     add: .pakFileList serverinfo cvar which contains all loaded pk4's files
          a client needs to connect to the server.
     add: match_respawnOnSD command to control respawn for sudden death.
     chg: matchtimer visible in warmup and sudden death ( always counts up )
     chg: teamoverlay now shows playerlocation / nearest item.
     chg: hud_drawTeamOverlay positioning: 1 upper right, 2 lower right and
          3 lower left.
     chg: r_displayRefresh works now in MP.
     chg: chat and teamchat appears in q3 style (requested).
     chg: g_gibs and g_blood renamed to cl_gibs and cl_blood.
     chg: recolored weaponmodel textures and glowtexture added.
     chg: scorebot serverinfo names got a . prefix.
          like .Score_Marine / .Score_Time etc.
          to allow smart serverbrowsers to display it sorted at the top of
          the list.
     chg: g_voteFlags now work for callvote.

   v0.11a ~ December 24th, 2005 (unsupported x-mas hotfix)

     fix: invisible items like armor, are now visible again.
     fix: rocketlauncher missing in warmup should be there again
          (we couldn't test it much, but until now it worked).
     fix: old health/armor values from previous teamgames are no longer drawn at
          crosshair in non team gametypes
     add: cl_weaponBobbing to toggle the serverside bobbing
     add: hud_weaponHighlight to control the hightlight style of the weaponswitch
     add: hud_ammoColor to control the colorizing of the ammo
     add: hud_weaponSwitch 3 to use osp/cpm like vertical weaponswitch
     add: cl_useScreenShotJPEG cmd to use .jpg instead of .tga's for screenies.
     chg: r_skipSpecular works now in MP
     chg: command prefix changed for most of the client commands from ui_ to cl_
          list of changed cvars:
          cl_enemyColorIntensity - cl_enemyColorArms - cl_enemyColorTorso
          cl_enemyColorLegs - cl_teamColorIntensity - cl_teamColorArms
          cl_teamColorTorso - cl_teamColorLegs - cl_rocketTrail - cl_grenadeTrail
          cl_nailTrail - cl_tinyRailTrail
     chg: slower fadeoff of crosshair aim info
     chg: ammo now right-justified for all weaponswitches
     chg: g_gun-position variables set to nocheat (changeable in multiplayer)
     chg: ambientlight now changeable without maprestart

   v0.10 ~ December 18th, 2005

     fix: pm_stairJumps <0|1> allows strafejumping on stairs
     chg: bobbing cvars can be changed in multiplayer
     chg: clientcallvote info in console
     chg: map weapons are now available during warmup.
     chg: crosshair size is adjustable stepless from 1-100
     chg: g_fov is allowed from 20-150
     chg: crosshair info distance raised
     chg: si_teamdamage <0|1|2>
     chg: hud_barStyle, hud_ammoBar, hud_ammoVisible, hud_weaponVisible and
          hud_weaponSwitch are now "true" cvars.
     add: readystatus in scoreboard
     add: si_freeModels <0|1> allow using of all models
     add: si_scoreBotSupport <0|1>
     add: si_scoreBotRefreshRate <1-60> scorebot-info refresh interval
     add: teamlock & teamunlock commands
     add: teamdamage is votable by gui ( multiplayer vote menu )
     add: pm_smoothBoxJumps <0-16> allow smoother jumping on boxes
     add: ui_weaponBobbing <0|1> toggles bobbing of weapon
     add: ui_rocketTrail <0|1> show/hide rockets smoke
     add: ui_grenadeTrail <0|1> show/hide grenades smoke
     add: ui_nailTrail <0|1> show/hide nailtrail
     add: ui_tinyRailTrail <0|1> dis-/enable the tiny railtrail
     add: ui_enemyColorArms  <RRGGBB> enemy models arms color
     add: ui_enemyColorLegs  <RRGGBB> enemy models legs color
     add: ui_enemyColorTorso <RRGGBB> enemy models torso color
     add: ui_teamColorArms  <RRGGBB> arms color
     add: ui_teamColorLegs  <RRGGBB> legs color
     add: ui_teamColorTorso <RRGGBB> torso color
     add: ui_teamColorIntensity  <0 - 1.0> specifies brightskins brightness
     add: ui_enemyColorIntensity <0 - 1.0> specifies brightskins brightness
     add: ui_teamForceColors <0-7> set which parts are forced to your teamcolors
     add: hud_showTeamHealth <0|1> display health/armor of teammates
     add: hud_drawTimer <0|1|2> toggles timer appearence
     add: hud_drawTeamOverlay <0|1> toggle teamoverlay
     add: hud_showJumps <0|1> display jump distance
     add: hud_showSpeed <0|1> display player speed
     add: hud_lagometerPosition <x y> to set the x/y position of the lagometer
     add: green armor support. +25 Armor. editorname: 'item_armor_jacket_mp'
     add: 'item_armor_jacket_mp' entity to editor under pickup->item menu
     add: g_blood <0|1> toggle the blood effects
     add: g_gibs <0|1> toggle the playergib effects
     add: g_fastWeaponSwitch <0|1> toggle sg/hb fast weaponswitch
     add: g_spawnType <0-3> set different player spawn behavior
     add: r_ambientLightOnly <0|1-2> to enable only ambientlights on the map.
     add: g_altMinRespawnLimit <0|1> toggles the use of alternative minimum
          spawn times for players.
     add: g_maxRespawnTime <2-60> changes the maximum spawn time for players
     add: s_altHitsounds <0-1> allows the usage of alternate (q3) hitsounds.
     add: 'callvote' as alias for clientCallvote

     \clientcallvotes:
     chg: teamdamage <0|1|2>     - see si_teamdamage
     add: stairjumps <0|1>       - see pm_stairjumps
     add: smoothboxjumps <0-16>  - see pm_smoothboxjumps
     add: freemodels <0|1>       - see si_freemodels
     add: fastswitch <0|1>       - see g_fastWeaponSwitch
     add: spawntype <0-3>        - see g_spawnType
     add: altminspawnlimit <0|1> - see g_altMinRespawnLimit
     add: maxrespawntime <n>     - see g_maxrespawntime

   v0.05 ~ November 12th, 2005

     chg: grenade texture changed and recolored
     chg: switched to another brightskin technique using shaders
     fix: corpse model has a brightskin now
     add: turned the machinegun sound down about 10db
     add: little gloweffect for weapons
     add: armor shards got a green brightskin
     add: hud_weaponvisible <0|1|2> Toggles the visability of the weapon bar
     add: hud_weaponswitch <0|1|2> Positions the weapon bar
     add: hud_ammovisible <0|1|2> Toggles the visibility of your current ammo
     add: hud_ammobar <0|1|2> Positions the current ammunition value
     add: hud_barstyle <0|1> How the Health/Armor/Ammo Bars are displayed (Beta)

   v0.04 beta ~ October 30th, 2005

     add: loading screen shows XBM version and URL
     add: removed all three startup intros.
     add: advanced HUD ( THX to SoRDiD-DDT )

   v0.03 beta ~ October 27th, 2005

     add: new brightskins for both teams
     add: deadbody brightskin

   v0.02 alpha ~ October  25th, 2005

     fix: missing marines and strogg models colored
     add: grenadecolor recolored to yellow/red

   v0.01 alpha ~ October 5th, 2005

     add: marine team models are forced to a bright green color
     add: one strogg team model recolored to be white
     add: grenadecolor recolored to green

 ~ eof ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
